/*

This material is Copyright 1995, 1996 Chris Hecker, All Rights Reserved.
It's for you to read and learn from, not to put in your own articles
or books or on your website, etc.  Thank you.

Chris Hecker
checker@netcom.com


++++++++++++
	Talk to the guy above about this file
	I only quickly converted it using an easier naming convention and to OOP to suit my needs
	NEEDS ASM BADLY
*/

/******** structures, inlines, and function declarations **********/
extern BITMAP *TestTexture[4];
extern BITMAP *offscreen;

class gradients_suba;
class edge_suba;
void DrawScanLine_suba(edge_suba *pLeft, edge_suba *pRight);

class gradients_suba {
public:
	float One_Z[3];				// 1/z for each vertex
	float U_Z[3];				// u/z for each vertex
	float V_Z[3];				// v/z for each vertex
	float One_Z_dX, One_Z_dY;	// d(1/z)/dX, d(1/z)/dY
	float U_Z_dX, U_Z_dY;		// d(u/z)/dX, d(u/z)/dY
	float V_Z_dX, V_Z_dY;		// d(v/z)/dX, d(v/z)/dY
	fixed16_16 dUdXMod;
	fixed16_16 dVdXMod;

	gradients_suba() {}
	void setup(P3D const *pVertices);
};

void gradients_suba::setup(P3D const *pVertices) {
	int counter;
	
	fixed28_4 X1Y0 = fixed28_4Mul(pVertices[1].x - pVertices[2].x, pVertices[0].y - pVertices[2].y);
	fixed28_4 X0Y1 = fixed28_4Mul(pVertices[0].x - pVertices[2].x, pVertices[1].y - pVertices[2].y);
	float OneOverdX = 1.0 / fixed28_4tof(X1Y0 - X0Y1);

	float OneOverdY = -OneOverdX;

	for(counter = 0;counter < 3;counter++) {
		float const OneOverZ = 1/pVertices[counter].z;
		One_Z[counter] = OneOverZ;
		U_Z[counter] = pVertices[counter].u * OneOverZ;
		V_Z[counter] = pVertices[counter].v * OneOverZ;
	}

	One_Z_dX = OneOverdX * (((One_Z[1] - One_Z[2]) *
			fixed28_4tof(pVertices[0].y - pVertices[2].y)) - ((One_Z[0] - One_Z[2]) *
			fixed28_4tof(pVertices[1].y - pVertices[2].y)));
	One_Z_dY = OneOverdY * (((One_Z[1] - One_Z[2]) *
			fixed28_4tof(pVertices[0].x - pVertices[2].x)) - ((One_Z[0] - One_Z[2]) *
			fixed28_4tof(pVertices[1].x - pVertices[2].x)));

	U_Z_dX = OneOverdX * (((U_Z[1] - U_Z[2]) *
			fixed28_4tof(pVertices[0].y - pVertices[2].y)) - ((U_Z[0] - U_Z[2]) *
			fixed28_4tof(pVertices[1].y - pVertices[2].y)));
	U_Z_dY = OneOverdY * (((U_Z[1] - U_Z[2]) *
			fixed28_4tof(pVertices[0].x - pVertices[2].x)) - ((U_Z[0] - U_Z[2]) *
			fixed28_4tof(pVertices[1].x - pVertices[2].x)));

	V_Z_dX = OneOverdX * (((V_Z[1] - V_Z[2]) *
			fixed28_4tof(pVertices[0].y - pVertices[2].y)) -
			((V_Z[0] - V_Z[2]) * fixed28_4tof(pVertices[1].y - pVertices[2].y)));
	V_Z_dY = OneOverdY * (((V_Z[1] - V_Z[2]) *
			fixed28_4tof(pVertices[0].x - pVertices[2].x)) - 	((V_Z[0] - V_Z[2]) * 
			fixed28_4tof(pVertices[1].x - pVertices[2].x)));

	fixed16_16 const Half = 0x8000;
	fixed16_16 const PosModifier = Half;
	fixed16_16 const NegModifier = Half - 1;

	float dUdXIndicator = U_Z_dX * One_Z[0] - U_Z[0] * One_Z_dX;

	if(dUdXIndicator > 0)
		dUdXMod = PosModifier;
	else {
		if(dUdXIndicator < 0)
			dUdXMod = NegModifier;
		else 	{
			float dUdYIndicator = U_Z_dY * One_Z[0] - U_Z[0] * One_Z_dY;

			if(dUdYIndicator >= 0)
				dUdXMod = PosModifier;
			else
				dUdXMod = NegModifier;
		}
	}

	float dVdXIndicator = V_Z_dX * One_Z[0] - V_Z[0] * One_Z_dX;

	if(dVdXIndicator > 0)
		dVdXMod = PosModifier;
	else {
		if(dVdXIndicator < 0)
			dVdXMod = NegModifier;
		else {
			float dVdYIndicator = V_Z_dY * One_Z[0] - V_Z[0] * One_Z_dY;

			if(dVdYIndicator >= 0)
				dVdXMod = PosModifier;
			else
				dVdXMod = NegModifier;
		}
	}
}

class edge_suba {
public:
	long X, XStep, Numerator, Denominator;			// DDA info for x
	long ErrorTerm;
	int Y, Height;					// current y and vertical count
	float OneOverZ, OneOverZStep, OneOverZStepExtra;// 1/z and step
	float UOverZ, UOverZStep, UOverZStepExtra;		// u/z and step
	float VOverZ, VOverZStep, VOverZStepExtra;		// v/z and step

	edge_suba(gradients_suba const &Gradients, P3D const *pVertices, int Top, int Bottom);
	inline int Step();
};

edge_suba::edge_suba(gradients_suba const &Gradients, P3D const *pVertices, int Top, int Bottom) {
	Y = ceil28_4(pVertices[Top].y);
	int YEnd = ceil28_4(pVertices[Bottom].y);
	Height = YEnd - Y;

	if(Height) {
		long dN = pVertices[Bottom].y - pVertices[Top].y;
		long dM = pVertices[Bottom].x - pVertices[Top].x;
	
		long InitialNumerator = dM*16*Y - dM*pVertices[Top].y +
					dN*pVertices[Top].x - 1 + dN*16;
		FloorDivMod(InitialNumerator,dN*16,X,ErrorTerm);
		FloorDivMod(dM*16,dN*16,XStep,Numerator);
		Denominator = dN*16;
	
		float YPrestep = fixed28_4tof(Y*16 - pVertices[Top].y);
		float XPrestep = fixed28_4tof(X*16 - pVertices[Top].x);
	
		OneOverZ = Gradients.One_Z[Top] + YPrestep * Gradients.One_Z_dY + XPrestep * Gradients.One_Z_dX;
		OneOverZStep = XStep * Gradients.One_Z_dX + Gradients.One_Z_dY;
		OneOverZStepExtra = Gradients.One_Z_dX;
	
		UOverZ = Gradients.U_Z[Top] + YPrestep * Gradients.U_Z_dY + XPrestep * Gradients.U_Z_dX;
		UOverZStep = XStep * Gradients.U_Z_dX + Gradients.U_Z_dY;
		UOverZStepExtra = Gradients.U_Z_dX;
	
		VOverZ = Gradients.V_Z[Top] + YPrestep * Gradients.V_Z_dY + XPrestep * Gradients.V_Z_dX;
		VOverZStep = XStep * Gradients.V_Z_dX + Gradients.V_Z_dY;
		VOverZStepExtra = Gradients.V_Z_dX;
	}
}

inline int edge_suba::Step() {
	X += XStep; Y++; Height--;
	UOverZ += UOverZStep; VOverZ += VOverZStep; OneOverZ += OneOverZStep;

	ErrorTerm += Numerator;
	if(ErrorTerm >= Denominator) {
		X++;
		ErrorTerm -= Denominator;
		OneOverZ += OneOverZStepExtra;
		UOverZ += UOverZStepExtra;
		VOverZ += VOverZStepExtra;
	}
	return Height;
}	

/******** TextureMapTriangle **********/
gradients_suba Gradients;
BITMAP *dest, *texture;
int dest_deltascan, tex_deltascan;

void TextureMapTri(BITMAP *Dest, P3D const *pVertices, BITMAP *Texture) {
	int Top, Middle, Bottom, MiddleForCompare, BottomForCompare;
	fixed28_4 Y0 = pVertices[0].y, Y1 = pVertices[1].y,	Y2 = pVertices[2].y;

	// put in global lookup so dont have to pass it in drawscanline function call  saves asm 'push' statements
	// ok... so i did modify it    so shoot me!
	texture=Texture;
	dest=Dest;
	dest_deltascan=((dest->w   +3) & ~3);
	tex_deltascan=((texture->w +3) & ~3);
	
 
	if(Y0 < Y1) {
		if(Y2 < Y0) {
			Top = 2; Middle = 0; Bottom = 1;
			MiddleForCompare = 0; BottomForCompare = 1;
		}
		else {
			Top = 0;
			if(Y1 < Y2) {
				Middle = 1; Bottom = 2;
				MiddleForCompare = 1; BottomForCompare = 2;
			}
			else {
				Middle = 2; Bottom = 1;
				MiddleForCompare = 2; BottomForCompare = 1;
			}
		}
	}
	else {
		if(Y2 < Y1) {
			Top = 2; Middle = 1; Bottom = 0;
			MiddleForCompare = 1; BottomForCompare = 0;
		}
		else {
			Top = 1;
			if(Y0 < Y2) {
				Middle = 0; Bottom = 2;
				MiddleForCompare = 3; BottomForCompare = 2;
			}
			else {
				Middle = 2; Bottom = 0;
				MiddleForCompare = 2; BottomForCompare = 3;
			}
		}
	}

	Gradients.setup(pVertices);
	edge_suba TopToBottom(Gradients,pVertices,Top,Bottom);
	edge_suba TopToMiddle(Gradients,pVertices,Top,Middle);
	edge_suba MiddleToBottom(Gradients,pVertices,Middle,Bottom);
	edge_suba *pLeft, *pRight;
	int MiddleIsLeft;

	// the triangle is clockwise, so if bottom > middle then middle is right
	if(BottomForCompare > MiddleForCompare) {
		MiddleIsLeft = 0;
		pLeft = &TopToBottom; pRight = &TopToMiddle;
	}
	else {
		MiddleIsLeft = 1;
		pLeft = &TopToMiddle; pRight = &TopToBottom;
	}

	int Height = TopToMiddle.Height;

	while(Height--) {
		DrawScanLine_suba(pLeft,pRight);
		TopToMiddle.Step(); TopToBottom.Step();
	}

	Height = MiddleToBottom.Height;

	if(MiddleIsLeft) {
		pLeft = &MiddleToBottom;
		pRight = &TopToBottom;
	}
	else {
		pLeft = &TopToBottom;
		pRight = &MiddleToBottom;
	}
	
	while(Height--) {
		DrawScanLine_suba(pLeft,pRight);
		MiddleToBottom.Step(); TopToBottom.Step();
	}
}

void DrawScanLine_suba(edge_suba *pLeft, edge_suba *pRight) {
	int XStart = pLeft->X;
	int Width = pRight->X - XStart;

	// attempting to port a windows DIB BITMAP to Allegro BITMAPS really sucked
	// mostly because i never touced WIN before in my life
	// had to go off of my knowedge of how (id's)Doom did it also
	// dont know how to get out of 8bit color yet as of 2000/7/14

	unsigned char  *pDestBits = &dest->line[pLeft->Y][XStart];
	unsigned char  *pTextureBits = texture->line[0];

	long TextureDeltaScan = tex_deltascan;

	int const AffineLength = 8;

	float OneOverZLeft = pLeft->OneOverZ;
	float UOverZLeft = pLeft->UOverZ;
	float VOverZLeft = pLeft->VOverZ;

	float One_Z_dXAff = Gradients.One_Z_dX * AffineLength;
	float U_Z_dXAff = Gradients.U_Z_dX * AffineLength;
	float V_Z_dXAff = Gradients.V_Z_dX * AffineLength;

	float OneOverZRight = OneOverZLeft + One_Z_dXAff;
	float UOverZRight = UOverZLeft + U_Z_dXAff;
	float VOverZRight = VOverZLeft + V_Z_dXAff;

	float ZLeft = 1/OneOverZLeft;
	float ULeft = ZLeft * UOverZLeft;
	float VLeft = ZLeft * VOverZLeft;

	float ZRight, URight, VRight;
	fixed16_16 U, V, DeltaU(0), DeltaV(0);

	if(Width > 0) {
		int Subdivisions = Width / AffineLength;
		int WidthModLength = Width % AffineLength;

		if(!WidthModLength)	{
			Subdivisions--;
			WidthModLength = AffineLength;
		}

		while(Subdivisions-- > 0)	{
			ZRight = 1/OneOverZRight;
			URight = ZRight * UOverZRight;
			VRight = ZRight * VOverZRight;
	
			U = fto16_16(ULeft) + Gradients.dUdXMod;
			V = fto16_16(VLeft) + Gradients.dVdXMod;
			DeltaU = fto16_16(URight - ULeft) / AffineLength;
			DeltaV = fto16_16(VRight - VLeft) / AffineLength;

			for(int counter = 0;counter < AffineLength;counter++)	{
				int UInt = U>>16;
				int VInt = V>>16;

				*(pDestBits++) = *(pTextureBits + UInt + (VInt * TextureDeltaScan));

				U += DeltaU;
				V += DeltaV;
			}
	
			ZLeft = ZRight;
			ULeft = URight;
			VLeft = VRight;
	
			OneOverZRight += One_Z_dXAff;
			UOverZRight += U_Z_dXAff;
			VOverZRight += V_Z_dXAff;
		}
	
		if(WidthModLength) {
			ZRight = 1/(pRight->OneOverZ - Gradients.One_Z_dX);
			URight = ZRight * (pRight->UOverZ - Gradients.U_Z_dX);
			VRight = ZRight * (pRight->VOverZ - Gradients.V_Z_dX);

			U = fto16_16(ULeft) + Gradients.dUdXMod;
			V = fto16_16(VLeft) + Gradients.dVdXMod;

			if(--WidthModLength) {
				// guard against div-by-0 for 1 pixel lines
				DeltaU = fto16_16(URight - ULeft) / WidthModLength;
				DeltaV = fto16_16(VRight - VLeft) / WidthModLength;
			}
	
			for(int counter = 0;counter <= WidthModLength;counter++) {
				int UInt = U>>16;
				int VInt = V>>16;
	
				*(pDestBits++) = *(pTextureBits + UInt + (VInt * TextureDeltaScan));
		
				U += DeltaU;
				V += DeltaV;
			}
		}
	}
}
